/* COPYRIGHT NOTICE
 *
 * This program comes from "The X Toolkit Cookbook" by Paul E. Kimball
 * c. 1995 Prentice Hall.
 *
 *  HDR1: Example 8-3 - buttons.c - Using client_data to pass button ID
 *  
 *  HDR2: Chapter 8, page 179
 *
 * This software is provided free of charge and may be freely distributed
 * in its original form, so long as this notice appears unchanged in each 
 * copy.  This software is supplied "as-is" and is not covered by warrantee
 * of any kind, express or implied.  
 *
 * This and other examples are available by anonymous ftp from
 * ftp.netcom.com, directory "pub/pk/pkimball/cookbook".
 *
 *  1/15/95	Paul Kimball - pkimball@netcom.com
 */

/***  Include Required Header Files   ****************************/

#include <X11/Intrinsic.h>  /* The Intrinsics                    */
#include <Xm/Xm.h>          /* Resource symbols                  */
#include <Xm/RowColumn.h>   /* Motif XmRowColumn                 */
#include <Xm/PushB.h>       /* Motif XmPushButton                */
#include <Xm/TextF.h>       /* Motif XmTextField                 */

/***  Declare Global Variables   *********************************/

Widget textf;               /* Text field widget ID              */
void OneCallback();         /* Callback routine                  */

/****** Start of main() ******************************************/

main(argc,argv)
int  argc;
char **argv;
{

 XtAppContext context;
 Widget toplevel, rowcol, btn1, btn2, btn3;

/*** Init. toolkit, application context and application shell  ***/

 toplevel = XtAppInitialize(&context, "Buttons", NULL, 0, 
     &argc, argv, NULL, NULL, 0);

 rowcol = XtCreateManagedWidget( "rowcol", xmRowColumnWidgetClass,
     toplevel, NULL, 0);

 textf = XtCreateManagedWidget( "textf", xmTextFieldWidgetClass,
     rowcol, NULL, 0);

 btn1 = XtCreateManagedWidget( "ButtonOne", xmPushButtonWidgetClass, 
     rowcol, NULL, 0 );

 btn2 = XtCreateManagedWidget( "ButtonTwo", xmPushButtonWidgetClass, 
     rowcol, NULL, 0 );

 btn3 = XtCreateManagedWidget( "ButtonThree", xmPushButtonWidgetClass, 
     rowcol, NULL, 0 );

/****** Register callbacks with different client_data ***************/

 XtAddCallback(btn1, XmNactivateCallback, OneCallback, (XtPointer)0 );
 XtAddCallback(btn2, XmNactivateCallback, OneCallback, (XtPointer)1 );
 XtAddCallback(btn3, XmNactivateCallback, OneCallback, (XtPointer)2 );

/****** Realize widget tree and start event loop ********************/

 XtRealizeWidget(toplevel);
 XtAppMainLoop(context);
}


/****** Callback Routines *******************************************/

void OneCallback( w, client_data, call_data )
Widget w;
XtPointer client_data;   /* Use to find which button was pressed*/
XtPointer call_data;
{
 static char *output_strings[] = { "One", "Two", "Three"};

 int index = (int)client_data;

 XtVaSetValues( textf, XmNvalue, output_strings[index], NULL);
}
