/* COPYRIGHT NOTICE
 *
 * This program comes from "The X Toolkit Cookbook" by Paul E. Kimball
 * c. 1995 Prentice Hall.
 *
 *  HDR1: Example 8-2 - repeated.c - Repeated callbacks
 *  
 *  HDR2: Chapter 8, page 175
 *
 * This software is provided free of charge and may be freely distributed
 * in its original form, so long as this notice appears unchanged in each 
 * copy.  This software is supplied "as-is" and is not covered by warrantee
 * of any kind, express or implied.  
 *
 * This and other examples are available by anonymous ftp from
 * ftp.netcom.com, directory "pub/pk/pkimball/cookbook".
 *
 *  1/15/95	Paul Kimball - pkimball@netcom.com
 */

/*** Include required header files **********************************/

#include <X11/Intrinsic.h>             /* The Intrinsics            */
#include <Xm/Xm.h>                     /* Motif symbols             */
#include <Xm/BulletinB.h>              /* XmBulletinBoard widget    */
#include <Xm/Label.h>                  /* XmLabel widget            */
#include <Xm/PushB.h>                  /* XmPushButton widget       */
#include <Xm/Scale.h>                  /* XmScale widget            */
#include <Xm/Text.h>                   /* XmText widget             */

/*** Declare global variables and callback routines ******************/

XtAppContext  context;                 /* Application context        */
Widget        toplevel, manager,       /* Widget tree                */
              scale, label, 
              text, exit_btn;

void Moving();                         /* repeated callback          */
void ExitCallback();                   /* exit callback              */

/*** Start of Main  **************************************************/

main(argc,argv)
int argc;
char **argv;
{
 toplevel = XtAppInitialize(&context, "Repeated", 
     NULL, 0, &argc, argv, NULL, NULL, 0);
      
 manager = XtCreateManagedWidget("manager",       /* XmBulletinBoard */
     xmBulletinBoardWidgetClass, toplevel, NULL, 0);

 scale = XtCreateManagedWidget("scale",           /* XmScale         */
     xmScaleWidgetClass, manager, NULL, 0);

 label = XtCreateManagedWidget("label",           /* XmLabel         */
     xmLabelWidgetClass, manager, NULL, 0);

 text = XtCreateManagedWidget("text",             /* XmText          */
     xmTextWidgetClass, manager, NULL, 0);

 exit_btn = XtCreateManagedWidget("exitBtn",      /* XmPushButton    */
     xmPushButtonWidgetClass, manager, NULL, 0);
 XtAddCallback(exit_btn, XmNactivateCallback, ExitCallback, NULL);

 XtAddCallback(scale, XmNdragCallback, Moving, NULL);
 XtAddCallback(scale, XmNvalueChangedCallback, Moving, NULL);

 XtRealizeWidget(toplevel);                       /* Realize all     */
 XtAppMainLoop(context);                          /* Start MainLoop  */
}

/***** Callback Routines *********************************************/

void 
Moving(w, client_data, call_data)               /* Called when scale */
Widget  w;                                      /* is dragged        */ 
XtPointer client_data, call_data;
{ 
 int value;
 char string[20];

 XtVaGetValues(scale, XmNvalue, &value, NULL);  /* Get scale value    */
 sprintf(string, "%d", value);                  /* Convert to string  */

 XtVaSetValues(text, XmNvalue, string, NULL);   /* display in text    */

}


void 
ExitCallback(w, client_data, call_data)         /* Called when exit   */
Widget  w;                                      /* button is activated*/
XtPointer client_data, call_data;
{
 exit(1);                                       /* we're history   */
}
